module Interactor
  module ClearContext
    module ContextAccessor

      def self.included(base)
        base.class_eval do
          extend ClassMethods
        end
      end

      module ClassMethods
        def self.require_contexts(*attributes)
          attr_writer attributes
          # define getter
          attributes.each do |attribute|
            define_method attribute do
              instance_variable_get("@#{attribute}") ||= context.send(attribute)
            end
          end
        end
      end

    end
  end
end
